import java.util.*;

/*
Lesen Sie die Aufgaben genau durch.
Schreiben bzw. vervollständigen Sie gekennzeichnete Programmteile wie in den Kommentaren beschrieben.
Verändern Sie aber nicht vorgegebene Methodenköpfe oder andere vorgegebene Programmteile!
*/
public class PotionCabinet {

    /*
    Aufgabe: Umgang mit Klassen und Objekten, sowie vorgefertigten Datenstrukturen.

        Ergänzen Sie fehlende Teile der Klassen Potion und Ingredient entsprechend den Kommentaren
        an den mit TODO gekennzeichneten Stellen.
        Sonstige Anforderungen: Es sollen keine zusätzlichen Methoden oder Objektvariablen
        implementiert werden.
        Hinweis: 'Cabinet' kann auch implementiert werden, ohne dass 'Potion' implementiert
        wird. In diesem Fall weichen die Ausgaben von den Sollausgaben ab.

    Punkte (maximal 34):

        20 Punkte in Summe für Klasse 'Potion':
            5 Punkte für den zweiten Konstruktor
            2 Punkt für 'stir'
            3 Punkt für 'ready'
            4 Punkte für 'power'
            6 Punkte für 'mixWith',
        14 Punkte für Klasse 'Cabinet':
            4 Punkte für den Konstruktor und Variablen
            6 Punkte für 'put'
            4 Punkte für 'toString'

    */

    // Diese Methode können Sie zum Testen der Klassen 'Potion' und 'Cabinet'
    // verwenden. Diese Methode wird nicht bewertet.
    public static void main(String[] args) {

        // Überprüft die korrekte Basisimplementierung der Klasse 'Potion':
        // Konstruktoren und 'toString'
        // Erwarteter Output:
        // [Bergblume, Säbelzahntigerauge]:27
        // [Bergblume, Weizen]:15
        // [Mondfalterflügel, Vampirstaub]:27
        Potion healing1 = new Potion(new String[]{"Bergblume","Säbelzahntigerauge"}, 3);
        Queue<String> ingr = new LinkedList<String>();
        ingr.offer("Bergblume");
        ingr.offer("Weizen");
        Potion healing2 = new Potion(ingr, 2);
        Potion invisibility = new Potion(new String[]{"Mondfalterflügel","Vampirstaub"}, 2);
        System.out.println(healing1);
        System.out.println(healing2);
        System.out.println(invisibility);

        // Überprüft die korrekte Implementierung der von 'stir':
        // Erwarteter Output:
        // [Bergblume, Säbelzahntigerauge]:54
        healing1.stir();
        healing1.stir();
        healing1.stir();
        System.out.println(healing1);

        // Überprüft die korrekte Basisimplementierung der Klasse 'Cabinet':
        // Konstruktoren und 'toString'
        // Erwarteter Output (Reihenfolge kann abweichen):
        // {Heilung=[Bergblume, Säbelzahntigerauge, Bergblume, Weizen]:84, Unsichtbarkeit=[Mondfalterflügel, Vampirstaub]:54}
        Cabinet potionArchive = new Cabinet();
        potionArchive.put("Heilung", healing1);
        potionArchive.put("Heilung", healing2);
        potionArchive.put("Unsichtbarkeit", invisibility);
        System.out.println(potionArchive);

    }

}


// Potion ist ein Zaubertrank mit einer beliebigen Anzahl an Zutaten. Er hat eine beliebige Anzahl an
// Zutaten und eine bestimmte Stärke, die sich aus der
// Summe der Stärken der Zutaten ergibt.
// Wird er fertig umgerührt wirkt er
// doppelt so stark.
class Potion {

    // Objektvariablen für den Zaubertrank. Es sind keine weiteren Objektvariablen zulässig.
    private String[] ingredients;
    private int howOftenToBeStired;
    private int howOftenStired = 0;

    // Konstruktor: initialisiert diesen Zaubertrank mit angegebenen Zutaten (ingredients)
    // und einem Wert, der angibt wie oft der Zaubertrank umgerührt werden muss,
    // bevor er fertig ist. Dieser Konstruktor ist bereits vorgegeben.
    public Potion(String[] ingredients, int howOftenToBeStired) {

        this.howOftenToBeStired = howOftenToBeStired;
        this.ingredients = ingredients;

    }

    // Fügt dem Zaubertrank die angegebene Zutat hinzu. Diese Methode ist bereits vorgegeben.
    public void add(String ingredient) {

        String[] ingredients = new String[this.ingredients.length+1];
        int i = 0;
        for (String ing: this.ingredients) {
            ingredients[i++] = ing;
        }
        ingredients[i] = ingredient;
        this.ingredients = ingredients;

    }

    // Ein weiterer Konstruktor: verhält sich wie obiger Konstruktor, nur werden die
    // Zutaten mittels Queue angegeben.
    public Potion(Queue<String> ingredients, int howOftenToBeStired) {

        this.howOftenToBeStired = howOftenToBeStired;

       String [] zutaten= new String[ingredients.size()];

        while (!ingredients.isEmpty()){
            for (int i=0; i< ingredients.size(); i++){
                zutaten[i] = ingredients.poll();
            }

        }
        this.ingredients = zutaten;


        //TODO: vervollständigen Sie den Konstruktor

    }

    // Rührt den Zaubertrank einmal um.
    public void stir() {
       this.howOftenStired ++;

        //TODO: implementieren Sie diese Methode

    }

    // Liefert die Stärke des Zaubertranks (int). Die Stärke ist die Summe
    // der Stringlängen aller Zutaten (ingredient), solange der Zaubertrank
    // nicht fertig ist. Ist er fertig umgerührt, wirkt er doppelt so stark.
    public int power() {
        int zutatenLaenge;
        String zutatenListe = "";

        for (String a :ingredients){
            zutatenListe += a;
        }

       zutatenLaenge=  zutatenListe.length();


        if (howOftenToBeStired ==howOftenStired){
            return zutatenLaenge *2;
        }


        return zutatenLaenge;


        //TODO: implementieren Sie diese Methode
        //TODO: diese Zeile entfernen oder entsprechend ändern

    }

    // Gibt an, ob Zaubertrank fertig ist, d.h. ausreichend oft umgerührt wurde.
    public boolean ready() {

        if (howOftenToBeStired == howOftenStired){
            return true;
        }

        //TODO: implementieren Sie diese Methode
        return false; //TODO: diese Zeile entfernen oder entsprechend ändern

    }

    // Fügt den angegebenen Zaubertrank zu diesem Zaubertrank hinzu.
    // Während 'potionToAdd' dabei unverändert bleibt, wird dieser Zaubertrank
    // dabei wie folgt verändert:
    // Alle Zutaten aus 'potionToAdd' werden hinzugefügt.
    // Die 'howOftenStired'-Werte von diesem Zaubertrank und von 'potionToAdd' werden
    // summiert. Ebenso werden die beiden 'howOftenToBeStired'-Werte summiert.
    public void mixWith(Potion potionToAdd) {
        this.howOftenToBeStired += potionToAdd.howOftenToBeStired;
        this.howOftenStired += potionToAdd.howOftenStired;
        // neues größeres array erstellen da arraygröße unveränderbar
        String [] zutatenKombiniert = new String[(this.ingredients.length)+ (potionToAdd.ingredients.length)];

        for (int i=0; i< this.ingredients.length;i++){
            zutatenKombiniert[i] = this.ingredients[i];
        }

        for (int j=this.ingredients.length-1; j< potionToAdd.ingredients.length; j++){
            zutatenKombiniert[j]= potionToAdd.ingredients[j];
        }


        this.ingredients = zutatenKombiniert;


        //TODO: implementieren Sie diese Methode

    }

    // Liefert einen String mit einer Liste der Zutaten in eckigen Klammern
    // gefolgt von einem ':' und der Stärke des Zaubertranks, also z.B.:
    // [Bergblume, Säbelzahntigerauge]:27
    // Diese Methode ist bereits gegeben.
    public String toString() {
        return Arrays.toString(ingredients) + ":" + power();
    }

}

// Repäsentiert einen Schrank mit Zaubertränken. Es können beliebig viele Tränke in den Schrank gestellt werden.
// Jeder Trank im Schrank bekommt eine Beschreibung seines Effektes.
class Cabinet {

    Map<String,Potion> schrankinhalt =new HashMap<>();



    // Erzeugt einen leeren Schrank.
    public Cabinet(Map<String,Potion> schrankinhalt) {
        this.schrankinhalt = schrankinhalt;


        //TODO: implementieren Sie den Konstruktor.

    }

    // Stellt einen Zaubertrank in den Schrank. Dabei wird die Beschreibung 'effect'
    // als Schlüssel verwendet, um später den Zaubertrank wieder zu finden.
    // Gibt es im Schrank bereits einen Zaubertrank mit der angegebenen Beschreibung,
    // wird 'potionToPut' dem bereits vorhandenen Zaubertrank hinzugefügt.
    // In jedem Fall wird sichergestellt, dass ein Zaubertrank der im Schrank steht,
    // fertig umgerührt ist.
    public void put(String effect, Potion potionToPut) {

        if (potionToPut.ready()){

            schrankinhalt.put(effect,potionToPut);


            if (schrankinhalt.containsKey(effect)){
                potionToPut.mixWith(potionToPut);
            }
        }
        //TODO: implementieren Sie diese Methode.

    }

    // Liefert eine lesbare Repräsentation (String) des Schranks in
    // folgendem Format:
    // {effect=Zaubertrank, effect=Zaubertrank, ... }
    // also z.B.
    // {Unsichtbarkeit=[Mondfalterflügel, Vampirstaub]:54, Heilung=[Bergblume, Säbelzahntigerauge, Bergblume, Weizen]:84}
    // Hinweis: Nutzen Sie ggfs. die toString-Methode der verwendeten Map Klasse (TreeMap, HashMap).
    public String toString() {

        //TODO: implementieren Sie diese Methode.
        return  "= "; //TODO: diese Zeile entfernen oder entsprechend ändern.

    }

}

