/*
Lesen Sie die Aufgaben genau durch.
Schreiben bzw. vervollständigen Sie gekennzeichnete Programmteile wie in den Kommentaren beschrieben.
Verändern Sie aber nicht vorgegebene Methodenköpfe oder andere vorgegebene Programmteile!
*/
public class Tree {

    /*
    Aufgabe:
        Objekte der Klasse Tree stellen binäre Suchbäume über ganzen Zahlen mit Knoten vom Typ Node dar.
        Ergänzen Sie fehlende Teile der Klasse entsprechend den Kommentaren an den mit TODO gekennzeichneten Stellen.

    Punkte (maximal 16):
        8 Punkte für copyTree,
        8 Punkte für toString.
        Auch für teilweise korrekte Lösungen werden Punkte vergeben.
    */

    class Node {

        // Keine zusätzlichen Varibalen definieren.
        private int elem;
        private Node left;
        private Node right;

        // Den Konstruktor nicht verändern.
        private Node(int elem) {
            this.elem = elem;
            this.left = null;
            this.right = null;
        }

        void add(int elem) {
            if (elem < this.elem) {
                if (this.left == null) {
                    this.left = new Node(elem);
                } else {
                    this.left.add(elem);
                }
            } else {
                if (this.right == null) {
                    this.right = new Node(elem);
                } else {
                    this.right.add(elem);
                }
            }
        }

        Node copyTree(){
            // TODO: Implementieren Sie die Methode
            return null; //TODO: Diese Zeile löschen oder entsprechend verändern.
        }

        @Override
        public String toString() {

            String retourstring = "";

            if (this.left ==null){
                  retourstring += "#"+ this;
            }
            else {
                this.left.toString();
            }

            if (this.right == null){
                retourstring += "#"+ this;
            }
            else {
                this.right.toString();
            }
            // TODO: Implementieren Sie die Methode
            return retourstring; //TODO: Diese Zeile löschen oder entsprechend verändern.
        }
    }


    // Der Wurzelknoten des Baumes. Bitte nicht verändern, oder zusätzliche
    // Variablen hinzufügen.
    private Node root;

    public boolean empty() {
        return this.root == null;
    }

    // Fügt neue Elemente in aufsteigend sortierter Reihenfolge in den Baum ein.
    // z.B. Die Aufrufe add(5),add(2),add(7),add(6),add(8),add(1),add(1),add(3)
    // ergeben folgenden Baum:
    //              5
    //           /    \
    //         2        7
    //       /   \     /  \
    //      1     3   6    8
    //       \
    //        1
    public void add(int elem) {
        if (empty()) {
            this.root = new Node(elem);
        } else {
            this.root.add(elem);
        }
    }

    // Diese Methode kopiert den vorhandenen Baum und erstellt eine exakte
    // Kopie. Dafür sollen keine zusätzliche Datenstrukturen verwendet werden.
    // Es wird der Wurzelknoten des kopierten Baumes zurückgegeben.
    public Node copyTree(){
        Tree copiedTree = new Tree();
        String baumInhalt = "";  //= voriger Baum.toString machen
        int baumInhaltLaenge = baumInhalt.length(); // = länge des InhaltsStrings


        for (int i =0; i< baumInhaltLaenge;i++){
            copiedTree.add(baumInhalt.charAt(i));
        }



        return copiedTree.root;





        // TODO: Implementieren Sie die Methode
        //return null; //TODO: Diese Zeile löschen oder entsprechend verändern.
    }

    // Retourniert alle Elemente des Baumes in aufsteigender Reihenfolge als
    // String.
    // z.B. der Baum enthält 1, 2, 3 and 4, dann ist das Ergebnis:
    // "(#4#3#2#1#)"
    // Für einen leeren Baum wird "()" zurückgegeben.
    @Override
    public String toString() {
        if (root ==null){
            return "()";
        }
        else {
            return root.toString();
        }


        // TODO: Implementieren Sie die Methode
    }

    // Nur zum Testen (geht nicht in die Beurteilung ein).
    public static void main(String[] args) {
    }
}


